/*****************************************************************************
 *
 * Atmel Corporation
 *
 * ̧		: HEXParser.hpp
 * ߲	: Dev-C++ 4.9.8.0 - http://bloodshed.net/dev/
 * 		: $Revision: 1163 $
 * t		: $Date: 2006N82 15:38:16 +0200 $
 * XV	: $Author: ohlia $
 *
 * xҰ	: avr@atmel.com
 *
 * ړI	: Win32
 *
 * pLq	: AVR911 - AVRJ݊
 *
 * 		: ȒPIntel HEXٌ̧`ǂݏ
 *
 ****************************************************************************/
#ifndef HEXPARSER_HPP
#define HEXPARSER_HPP

using namespace std;

#include "ErrorMsg.hpp"
#include "Utility.hpp"
#include <iostream>
#include <fstream>
#include <iomanip>

struct HEXRecord;							// b`

class HEXFile
{
	protected:
		unsigned char * data;					// ް ޲Ăێ
		long start, end;						// gpް͈
		long size;								// ްɏՕ̑傫

		void writeRecord( ofstream & f, HEXRecord * recp );
		void parseRecord( const string & hexLine, HEXRecord * recp );

	public:
		/* ݽ׸ */
		HEXFile( long buffersize, long value = 0xff );

		/* ޽׸ */
		~HEXFile();

		/* ҿ */
		void readFile( const string & _filename );		// HEX̧قްǂݍ
		void writeFile( const string & _filename );		// HEX̧قް

		void setUsedRange( long _start, long _end );	// gp͈͂ݒ
		void clearAll( long value = 0xff );				// ްɏՕ̒lɐݒ

		long getRangeStart() { return start; }
		long getRangeEnd() { return end; }
		long getData( long address );
		void setData( long address, long value );
		long getSize() { return size; }
};

#endif
